@ECHO OFF
ECHO Set TAO environment
ECHO "TAO_ROOT must be setup early"
ECHO "Setting environment ...."

cd examples

call setenv.bat

ECHO Set Microsoft Visual Studio Environment using VS supplied batch file

IF "%VS_ENV_SCRIPT%"=="" EXIT 1

IF NOT "%VS_ENV_SCRIPT%"=="" call "%VS_ENV_SCRIPT%"

cd "%OSPL_HOME%"

ECHO Set OSPL runtime environment
call release.bat

ECHO Change to the examples directory

cd "%OSPL_HOME%"/examples

ECHO Build examples

IF "%VS80COMNTOOLS%"=="" devenv examples.sln /upgrade

devenv /useenv examples.sln /Build %BUILD_CONFIG%

ECHO Build Java examples
ECHO Building dcps/standalone/Java/PingPong
cd "%OSPL_HOME%/examples/dcps/standalone/Java/PingPong"
call BUILD.bat

ECHO Building dcps/standalone/Java/Tutorial
cd "%OSPL_HOME%/examples/dcps/standalone/Java/Tutorial"
call BUILD.bat

ECHO Building dcps/CORBA/Java/JacORB/PingPong
cd "%OSPL_HOME%/examples/dcps/CORBA/Java/JacORB/PingPong"
call BUILD.bat

ECHO Building dcps/CORBA/Java/JacORB/Tutorial
cd "%OSPL_HOME%/examples/dcps/CORBA/Java/JacORB/Tutorial"
call BUILD.bat

cd "%OSPL_HOME%/examples"

ECHO Check for DLRL directory

IF NOT EXIST "%OSPL_HOME%/examples/dlrl/" GOTO NODLRL

ECHO Build dlrl examples
ECHO Not building dlrl/standalone/C++/Tutorial because there is no BUILD.bat
REM cd "%OSPL_HOME%/examples/dlrl/standalone/C++/Tutorial"
REM call BUILD.bat

ECHO Building dlrl/standalone/Java/Tutorial
cd "%OSPL_HOME%/examples/dlrl/standalone/Java/Tutorial"
call BUILD.bat

GOTO END

:NODLRL
ECHO No DLRL examples to build

:END

ECHO ON

cd "%~dp0\..\..\..\testsuite\tests"

ECHO Building system testcases

IF "%VS80COMNTOOLS%"=="" devenv tests.sln /upgrade

devenv /useenv tests.sln /Build %BUILD_CONFIG%

ECHO OFF

cd "%OSPL_HOME%/examples"

