/*
 *                         OpenSplice DDS
 *
 *   This software and documentation are Copyright 2006 to 2009 PrismTech 
 *   Limited and its licensees. All rights reserved. See file:
 *
 *                     $OSPL_HOME/LICENSE 
 *
 *   for full copyright notice and license terms. 
 *
 */
/*
 * Implements PA abstraction for x86
 */

#if defined(__powerpc64__)
#    define LWSYNC	lwsync
#elif defined(CONFIG_E500)
#    define LWSYNC					\
	START_LWSYNC_SECTION(96);			\
	sync;						\
	MAKE_LWSYNC_SECTION_ENTRY(96, __lwsync_fixup);
#else
#    define LWSYNC	sync
#endif

#ifdef CONFIG_SMP
#define ISYNC_ON_SMP	"\n\tisync\n"
#define LWSYNC_ON_SMP	stringify_in_c(LWSYNC) "\n"
#else
#define ISYNC_ON_SMP
#define LWSYNC_ON_SMP
#endif

os_uint32
pa_increment(
    os_uint32 *count)
{
    os_uint32 value;

    __asm__ __volatile__(
            LWSYNC_ON_SMP
    "1:     lwarx    %0,0,%1    # atomic_inc\n \
            addic    %0,%0,1\n"
    "       stwcx.   %0,0,%1 \n\
            bne-     1b"
            ISYNC_ON_SMP
            : "=&r" (value)
            : "r" (count)
            : "cc", "xer", "memory");

    return value;
}

os_uint32
pa_decrement(
    os_uint32 *count)
{
    os_uint32 value;

    __asm__ __volatile__(
            LWSYNC_ON_SMP
    "1:     lwarx    %0,0,%1    # atomic_dec\n \
            addic    %0,%0,-1\n"
    "       stwcx.   %0,0,%1 \n\
            bne-     1b"
            ISYNC_ON_SMP
            : "=&r" (value)
            : "r" (count)
            : "cc", "xer", "memory");

    return value;
 return value;
}
